//CFileStat - Copyright 1998 by JD Glaser - ALL RIGHTS RESERVED
//NTFS file statistics viewer

 ********************************************************************
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version. *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details. *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 



#if !defined(AFX_FILESTAT_H__E7A4DDE3_7357_11D2_991B_006008310AEB__INCLUDED_)
#define AFX_FILESTAT_H__E7A4DDE3_7357_11D2_991B_006008310AEB__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afx.h>
#include <winnt.h>
#include <iostream.h>

typedef enum _KINDS_OF_ACCESSMASKS_DECODED
 { 
    FileAccessMask, 
    ProcessAccessMask, 
    WindowStationAccessMask, 
    DesktopAccessMask, 
    RegKeyAccessMask, 
    ServiceAccessMask, 
    DefaultDaclInAccessTokenAccessMask 
 }KINDS_OF_ACCESSMASKS_DECODED, *PKINDS_OF_ACCESSMASKS_DECODED; 


class CFileStat : public CObject  
{
	DECLARE_SERIAL(CFileStat)

public:
	void SetDump();
	void Reset();
	CFileStat();
	virtual ~CFileStat();

	int PrintStats();
	int RecordSecStats(LPTSTR lpszFullName);

private:
	BOOL SetPrivilegeInAccessToken(VOID);
	void InitializeWellKnownSIDs(VOID);
	BOOL LookupSIDName(PSID psidSID, LPTSTR lpszOldIndent); 
	void EnableBCKprivs();

	BOOL ExamineSD(PSECURITY_DESCRIPTOR psdSD, 
                   KINDS_OF_ACCESSMASKS_DECODED kamKindOfMask);
	BOOL ExamineACL(PACL paclACL, LPTSTR lpszOldIndent, 
							KINDS_OF_ACCESSMASKS_DECODED kamKindOfMask);
	void ExamineMask(ACCESS_MASK amMask, KINDS_OF_ACCESSMASKS_DECODED kamKindOfMask);

	BOOL SIDStringName(PSID psidSID, LPTSTR lpszSIDStringName);

    // file stats
	CString		m_strFileName;
	DWORD       m_dwFileAttributes; 
	CStringList m_PrintList;
	int			m_iFileCount;
	int			m_iBADdaclCount;
	int			m_iAllowedCount;
	int			m_iDeniedCount;
	bool		m_bDisordered;
	bool		m_bDumpDACL;


    // file security stats
	WIN32_FILE_ATTRIBUTE_DATA	m_attrFile; 
	SECURITY_DESCRIPTOR			m_SecDesc;
    

	//WELL KNOWN SIDS
	PSID m_psidNullSid; 
	PSID m_psidWorldSid; 
	PSID m_psidLocalSid; 
	PSID m_psidCreatorOwnerSid; 
	PSID m_psidCreatorGroupSid; 
	PSID m_psidNtAuthoritySid; 
	PSID m_psidDialupSid; 
	PSID m_psidNetworkSid; 
	PSID m_psidBatchSid; 
	PSID m_psidInteractiveSid; 
	PSID m_psidLogonIdsSid; 
	PSID m_psidServiceSid; 
	PSID m_psidLocalSystemSid; 
	PSID m_psidBuiltinDomainSid;

};	

#endif // !defined(AFX_FILESTAT_H__E7A4DDE3_7357_11D2_991B_006008310AEB__INCLUDED_)