//FileStat v1.0 - Copyright 1998 by JD Glaser - ALL RIGHTS RESERVED
//NTFS file statistics viewer

 ********************************************************************
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version. *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details. *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

#if !defined(AFX_FILESTAT_H__E7A4DDE3_7357_11D2_991B_006008310AEB__INCLUDED_)
#define AFX_FILESTAT_H__E7A4DDE3_7357_11D2_991B_006008310AEB__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <afx.h>
#include <winnt.h>
#include <iostream.h>
#include <iomanip.h>
#include <time.h>

typedef enum _KINDS_OF_ACCESSMASKS_DECODED
 { 
    FileAccessMask, 
    ProcessAccessMask, 
    WindowStationAccessMask, 
    DesktopAccessMask, 
    RegKeyAccessMask, 
    ServiceAccessMask, 
    DefaultDaclInAccessTokenAccessMask 
 }KINDS_OF_ACCESSMASKS_DECODED, *PKINDS_OF_ACCESSMASKS_DECODED; 


class CFileStat : public CObject  
{
	DECLARE_SERIAL(CFileStat)

public:
	void ExamineMask(ACCESS_MASK amMask, KINDS_OF_ACCESSMASKS_DECODED kamKindOfMask);
	void GetAudited(CString strDirName);
	void ParseAttribs(DWORD attribs);
	int PrintStats();
	int GetFileTimes(CString& createTime, CString& modTime);
	int GetFileAttribs(CString fileName);
	CFileStat();
	virtual ~CFileStat();

private:
	int RecordSecStats();
	BOOL SetPrivilegeInAccessToken(VOID);
	void InitializeWellKnownSIDs(VOID);
	BOOL ExamineSD(PSECURITY_DESCRIPTOR psdSD, 
                   KINDS_OF_ACCESSMASKS_DECODED kamKindOfMask);
	BOOL ExamineACL(PACL paclACL, LPTSTR lpszOldIndent, 
							KINDS_OF_ACCESSMASKS_DECODED kamKindOfMask);
	BOOL SIDStringName(PSID psidSID, LPTSTR lpszSIDStringName);
	BOOL LookupSIDName(PSID psidSID, LPTSTR lpszOldIndent); 
	void DumpHeader(WIN32_STREAM_ID& wsi, int iCount);
	void EnableBCKprivs();
	int ListStreams();

    // file stats
	CString		m_strFileName;
	DWORD       m_dwFileAttributes; 

    // file security stats
	WIN32_FILE_ATTRIBUTE_DATA	m_attrFile; 
	SECURITY_DESCRIPTOR			m_SecDesc;
    
	// file alternate data stats
	long		m_lStreamCount;
	long		m_lStreamSizes[5];
	CString		m_strStreamNames[5];
	DWORD		m_dwFileSize;
	CString		m_strCreationTime;
	CString		m_strModifiedTime;
	CString     m_strAccessTime;

	//file attribute stats
	BOOL m_bArchive;			//FILE_ATTRIBUTE_ARCHIVE		
	BOOL m_bCompressed;			//FILE_ATTRIBUTE_COMPRESSED	
	BOOL m_bDirectory;			//FILE_ATTRIBUTE_DIRECTORY	
	BOOL m_bHidden;				//FILE_ATTRIBUTE_HIDDEN		
	BOOL m_bNormal;				//FILE_ATTRIBUTE_NORMAL		
	BOOL m_bOffLine;			//FILE_ATTRIBUTE_OFFLINE		
	BOOL m_bReadOnly;			//FILE_ATTRIBUTE_READONLY		    
	BOOL m_bSystem;				//FILE_ATTRIBUTE_SYSTEM		
	BOOL m_bTemp;				//FILE_ATTRIBUTE_TEMPORARY

	//BOOL m_bReparsePoint;		//FILE_ATTRIBUTE_REPARSE_POINT
	//BOOL m_bSparse;				//FILE_ATTRIBUTE_SPARSE_FILE	
	//BOOL m_bEncrypted;			//FILE_ATTRIBUTE_ENCRYPTED	

	//WELL KNOWN SIDS
	PSID m_psidNullSid; 
	PSID m_psidWorldSid; 
	PSID m_psidLocalSid; 
	PSID m_psidCreatorOwnerSid; 
	PSID m_psidCreatorGroupSid; 
	PSID m_psidNtAuthoritySid; 
	PSID m_psidDialupSid; 
	PSID m_psidNetworkSid; 
	PSID m_psidBatchSid; 
	PSID m_psidInteractiveSid; 
	PSID m_psidLogonIdsSid; 
	PSID m_psidServiceSid; 
	PSID m_psidLocalSystemSid; 
	PSID m_psidBuiltinDomainSid;

};	

#endif // !defined(AFX_FILESTAT_H__E7A4DDE3_7357_11D2_991B_006008310AEB__INCLUDED_)