//FileStat v1.3.1 - Copyright JD Glaser 1998
//Dumps NTFS security, file, and stream attributes"

 ********************************************************************
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version. *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details. *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

#include "FileStat.h"

void PrintHelp();

void main(int argc, char* argv[])
{
	// check if running on Windows NT, if not, display notice and terminate 
    if( GetVersion() & 0x80000000 ) 
    { 
      printf("FileStat only runs on Windows NT and NTFS partitions");
      return; 
    }

try
{

	//set thread priority to lowest
	HANDLE hThread;
	hThread = ::GetCurrentThread();
	::SetThreadPriority(hThread, THREAD_PRIORITY_LOWEST);

	//Our file stat guy
	CFileStat fs;

	//get params
	for (int ctr = 1; ctr <= argc; ctr++)
	{
		CString strArgument = "";
		strArgument = argv[ctr];

		if(argc < 2)
		{
			PrintHelp();
			return;
		}

		if(strArgument == "-?" || strArgument == "/?") // -s == search for successful logon
		{
			PrintHelp();
			return;
		}

		//Attempted Garbage filter - resubmit switches
		if(strArgument != "")
		{
			printf("Dumping %s...", strArgument);
			if(!fs.GetFileAttribs(strArgument))
			{
				cout << "\nUnable to open " << strArgument << "...";
				return;
			}

		}
	}

    //show the details
	fs.PrintStats();
	cout << "\nDump complete..."; 

	return;
}

	catch(...)
	{
		printf("\nError - Shutting Down...");
		return;
	}
}

void PrintHelp()
{
	cout << "FileStat v1.4.1 Copyright(c) 1998, NT OBJECTives, Inc." << endl;
	cout << "Dumps NTFS security, file, and stream attributes" << endl;
	cout << "Programming by JD Glaser - All Rights Reserved" << endl;
	cout << "Command Line Switches" << endl;
	cout << "\t" << "[Filename]" << "\t" << "Name of file to list" << endl;
	cout << "\t" << "-?" << "\t" << "Help" << endl;
	cout << "See http://www.ntobjectives.com for updates/fixes" << endl;
	return;
}